; Quelle:xref-info2.LSP
; Checken und ggf umbenennen von Referenznamen externer Dateien
; AutoCAD2000/MDT4
; IR-ABG, Cornelia Schroeter
; V 1.0, 06.03.2002

; Ermitteln der Xrefs
(defun c:refn-chck ()
(setq nx nil
      leerz nil
      xna nil
      xnav nil
      xdatn nil
      xreftab nil
      count 0
)

(setq refcmdecho (getvar "cmdecho"))
(setvar "cmdecho" 0)


(setq xreftab (tblnext "block" t))
(while xreftab
  (setq xnav nil)
  (setq xreftab (tblnext "block"))
  (xrfdat)					; Daten auslesen
) ;while

(if (>= count 1)
 (progn
   (textscr)
;   (princ "\n\n**************   neue Referenzzuordnung:")
;   (command "_-xref" "?" "*")
   (princ (strcat "\n\n**************   Es wurden " (itoa count) " Referenznamen umbenannt. IR-ABG, cs"))
   (princ)
 ) ;progn
) ;if


(setvar "cmdecho" refcmdecho)
) ;defun

;---------------------------------------
; Xref-Daten auslesen
(defun xrfdat ()
(setq   nx (cdr (assoc 2 xreftab))  		;Referenz/Blockname
        xna (cdr (assoc 1 xreftab))		;Xref-Pfad
        xug (cdr (assoc 70 xreftab))
) ;setq

(if (or (= xug 36) (= xug 4) (= xug 32)) (ren_ref))

) ;defun



;---------------------------------------
; Umbenennen der Referenznamen
(defun ren_ref ()
;(setq xdatn (substr xna (- (strlen xna) 16) 13)) ;voraussetzung: dateiname ist 13stellig

;abg-cs 15.10.2002 auch Dateinamen mit weniger als 13 Zeichen werden nun beruecksichtigt
(setq countbslash (strlen xna))
(while (not (= (ascii (substr xna countbslash 1)) 92))
   (setq countbslash (1- countbslash))
;   (princ (substr xna countbslash))
)
(setq countbslash (1+ countbslash))
(setq xdatn (substr xna countbslash (- (strlen xna) countbslash 3)))

(if (/= nx xdatn)
    (progn

      (if (= count 0)
        (progn
;         (princ "\n\n**************   alte Referenzzuordnung:")
;         (command "_-xref" "?" "*")
        )
      )

      (princ "\n\n**************   Referenzen werden umbenannt ... ")
      (command "_rename" "bl" (eval nx) (eval xdatn) )
      (princ)
      (setq count (1+ count))
    )
    (princ "Refnamen: keine Differenzen gefunden.")
)

(textscr)
);defun
;---------------------------------------
(princ "refn-chck.LSP 1.0 geladen. \nStart mit 'refn-chck'")


